=== debian/changelog ===
picolibc (1.8.9-2) unstable; urgency=medium

  * Make sure aarch64 runs tests under qemu

  * Enable autopkgtest on arm64 and s390x too.

 -- Keith Packard <keithp@keithp.com>  Fri, 07 Feb 2025 15:21:28 -0800

picolibc (1.8.9-1) unstable; urgency=medium

  * New upstream

  * Build with new gcc-arm-none-eabi version.

 -- Keith Packard <keithp@keithp.com>  Wed, 05 Feb 2025 10:39:22 -0800
